"""Annotate dictionaries
"""
from .group import GroupAnnotator
from .service import ServiceAnnotator
from .variable import VariableAnnotator, CONVERT_OPTION
from .check import CheckAnnotator
from .value import ValueAnnotator
from .condition import ConditionAnnotator
from .fill import FillAnnotator
from .family import FamilyAnnotator, modes
from .property import PropertyAnnotator

class SpaceAnnotator:  # pylint: disable=R0903
    """Transformations applied on a CreoleObjSpace instance
    """
    def __init__(self, objectspace, eosfunc_file):
        self.objectspace = objectspace
        GroupAnnotator(objectspace)
        ServiceAnnotator(objectspace)
        VariableAnnotator(objectspace)
        CheckAnnotator(objectspace,
                       eosfunc_file,
                       )
        ConditionAnnotator(objectspace)
        FillAnnotator(objectspace,
                      eosfunc_file,
                      )
        FamilyAnnotator(objectspace)
        PropertyAnnotator(objectspace)
        ValueAnnotator(objectspace)


__all__ = ('SpaceAnnotator', 'CONVERT_OPTION', 'modes')
